<?php

require("/usr/share/bm-stats/www/conf/config.php");
require("/usr/share/bm-stats/www/function/date.php");
require("/usr/share/bm-stats/www/function/lang.php");
require("/usr/share/bm-stats/www/class/smtp/Class.SMTP.php");


require ("/usr/share/bm-stats/scripts/PHP/do_report/function/function.php");

require_once('/usr/share/bm-stats/scripts/PHP/tcpdf/config/lang/eng.php');
require_once('/usr/share/bm-stats/scripts/PHP/tcpdf/tcpdf.php');


$mkyesterday = mktime(0,0,0,date("m"),date("d")-1,date("Y")); // la veille <=> dernier jour du mois precedent
$this_year   = date("Y",$mkyesterday);
$this_month  = date("m",$mkyesterday); 
$this_yesterday = date("Y-m-d",$mkyesterday);
$resm  = date("Y_m",$mkyesterday);
$this_num_day = date("z",$mkyesterday);


$bm_domain_figures = get_bm_figure() ;


foreach( array_keys($bm_domain_figures) as $this_domain) {

    $myLang = getLang($this_domain) ;
    if(!empty($myLang)) $lang=$myLang ;
    require("/usr/share/bm-stats/www/inc_lang/inc_lang_$lang.php");
    require("/usr/share/bm-stats/www/inc_lang/inc_lang_smtp_$lang.php");


    $this_litt_yesterday = get_litteral_date($this_yesterday);

    $path_stat_img = $path_to_data.$this_domain."/img/$this_year/";
    $path_reporting_files_dir = $path_to_data.$this_domain."/reporting/";
    $path_to_resume_xml=$path_to_data.$this_domain."/xml/resume/";
    $path_to_resume_xmlDomain=$path_to_data.$this_domain."/xmlGlobalDomain/resume/";
    $path_to_resume_xmlDomainOutgoing = $path_to_data.$this_domain."/xmlGlobalDomainOutgoing/resume/";

    verif_existence_rep($path_reporting_files_dir);

    $filename = $path_reporting_files_dir."bmStats_report_".$this_yesterday.".pdf";

    // create new PDF document
    $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);



    // set document information
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->SetAuthor('Blue-Mind Stats');
    $pdf->SetTitle($pdfreport_SetTitle);
    $pdf->SetSubject($pdfreport_SetSubject);
    $pdf->SetKeywords($pdfreport_SetKeywords);

    // set default header data
    $pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, $pdfreport_SetHeaderDataTitle.' : '.$this_litt_yesterday, PDF_HEADER_STRING);

    // set header and footer fonts
    $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
    $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

    // set default monospaced font

    //set margins
    $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
    $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
    $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

    //set auto page breaks
    $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

    //set image scale factor
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

    //set some language-dependent strings
    $pdf->setLanguageArray($l);

    // set font
    $pdf->SetFont('dejavusans', '', 10);


    $star = "<sup><font size=\"6px\">(*)</font></sup>";
    $refStar = "<font size=\"9px\" color=\"#666\"><i>(*) : $pdfreport_unlimited</i></font>";


    /*
    1rst Page 
    */
    $pdf->AddPage();
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $html ='
    <table width="100%" cellpadding="0" cellspacing="0" border="0" >
     <tr><td height="300"></td></tr>
     <tr>
      <td valign="middle" align="center">
            <img src="/usr/share/bm-stats/scripts/PHP/tcpdf/images/image_page_garde.jpg" width="1000" height="287">
      </td>
     </tr>
    </table>';
    $pdf->writeHTML($html, true, false, true, false, '');



    /*
    1rst Chapter : Global figures of the server and this domain
    */
    $title = "$pdfreport_domain  \"$this_domain\" ";

    $pdf->AddPage();
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('1) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">1) <u>'.$title.'</font></u></b> :<br>
    <br>';
    $pdf->writeHTML($html, true, false, true, false, '');




    $title = $pdfreport_account;
    $pdf->Bookmark('1-1) '.$title.'', 1, 0, '', '', array(128,0,0));

    $html ='
    <b>1-1) '.$title.' :</b><br>
    <br>
    <table cellpadding="1" cellspacing="0" border="1" >
    <tr>
        <td> '.$pdfreport_createdAccount.'</td>
        <td align="center">'.$bm_domain_figures[$this_domain][account].'</td>
    </tr>

    <tr>
        <td> '.$pdfreport_createdMbox.'</td>
        <td align="center">'.$bm_domain_figures[$this_domain][mbox].'</td>
    </tr>

    <tr>
        <td> '.$pdfreport_redirectedAccount.'</td>
        <td align="center">'.$bm_domain_figures[$this_domain][redirected_mbox].'</td>
    </tr>
    </table><br><br>';
        
    $pdf->writeHTML($html, true, false, true, false, '');




    $title = $pdfreport_quota;
    $pdf->Bookmark('1-2) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html ='
    <b>1-2) '.$title.' '.$star.' :</b><br>
    <br>
    <table cellpadding="1" cellspacing="0" border="1" >
    <tr>
            <td> '.$pdfreport_quotaUnlim.'</td>
            <td align="center">'.$bm_domain_figures[$this_domain][quota_unlim].'</td>
    </tr>
    <tr>
            <td> '.$pdfreport_minQuota.'</td>
            <td align="center">'.$bm_domain_figures[$this_domain][min_mbox_quota].'</td>
    </tr>
    <tr>
            <td> '.$pdfreport_maxQuota.'</td>
            <td align="center">'.$bm_domain_figures[$this_domain][max_mbox_quota].'</td>
    </tr>

    <tr>
            <td> '.$pdfreport_averageQuota.'</td>
            <td align="center">'.$bm_domain_figures[$this_domain][ceil_quota].'</td>
    </tr>

    <tr>
            <td> '.$pdfreport_usedAverageQuota.'</td>
            <td align="center">'.$bm_domain_figures[$this_domain][ceil_used_quota].'</td>
    </tr>
    </table>'.$refStar.'<br><br>';

    $pdf->writeHTML($html, true, false, true, false, '');



    if($bm_domain_figures[$this_domain][archive][count] > 0) {

        $title="$pdfreport_archivedAccountList" ;
        $pdf->Bookmark('1-3) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html ='
        <b>1-3) '.$title.' :</b>
        <ul>';

        foreach($bm_domain_figures[$this_domain][archive][address] as $archive) {
            if(!empty($archive)) {
            $html .='<li>'.$archive.'</li>';
            };
        };

        $html .='
        </ul>
        <br>
        ';

        $pdf->writeHTML($html, true, false, true, false, '');
    };

    /*
    2nd Chapter : Domain activity (graphs) 
    */

    $title = $pdfreport_domainActivity." ";

    $pdf->AddPage('L','A4');
    $pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $pdf->Bookmark('2) '.$title.'', 0, 0, '', '', array(128,0,0));
    $html = '
    <br><br>
    <b><font size="12px">2) <u>'.$title.'</font></u></b> :<br>
    <br>';
    $pdf->writeHTML($html, true, false, true, false, '');

    //$path_stat_img = $path_to_data.$this_domain."/img/$this_year/";
    if(is_file($path_stat_img.'M'.$this_month.'_outgoing.png')) {

        $title = $pdfreport_sentNb;
        $pdf->Bookmark('2-1) '.$title.'', 2, 0, '', '', array(128,0,0));
        $html ='
            <b>2-1) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_outgoing.png" width="1000" height="300"><br>
            <br>
	';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if(is_file($path_stat_img.'M'.$this_month.'_outgoingvol.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_sentVolume ;
        $pdf->Bookmark('2-2) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = '
            <b>2-2) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_outgoingvol.png" width="1000" height="300"><br>
        ';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if(is_file($path_stat_img.'M'.$this_month.'_ingoing.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_receivedNb ;
        $pdf->Bookmark('2-3) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = '
            <b>2-3) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_ingoing.png" width="1000" height="300"><br>
        ';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if(is_file($path_stat_img.'M'.$this_month.'_deferred.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_deferredNb ;
        $pdf->Bookmark('2-4) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = ' 
            <b>2-4) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_deferred.png" width="1000" height="300"><br>
        ';
    	$pdf->writeHTML($html, true, false, true, false, '');
    };


    if (is_file($path_stat_img.'M'.$this_month.'_bounced.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_bouncedNb ;
        $pdf->Bookmark('2-5) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = '
            <b>2-5) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_bounced.png" width="1000" height="300"><br>
        ';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if (is_file($path_stat_img.'M'.$this_month.'_nbAtt.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_nbAtt ;
        $pdf->Bookmark('2-6) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = '
            <b>2-6) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_nbAtt.png" width="630" height="378"><br>
        ';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if (is_file($path_stat_img.'M'.$this_month.'_volAtt.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_volAtt ;
        $pdf->Bookmark('2-7) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = '
            <b>2-7) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_volAtt.png" width="630" height="378"><br>
        ';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if (is_file($path_stat_img.'M'.$this_month.'_mimeOff.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_mimeOff ;
        $pdf->Bookmark('2-8) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = '
            <b>2-9) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_mimeOff.png" width="630" height="378"><br>
        ';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if (is_file($path_stat_img.'M'.$this_month.'_mimePict.png')) {
        $pdf->AddPage('L','A4');
    	$pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
        $title = $pdfreport_mimePict ;
        $pdf->Bookmark('2-10) '.$title.'', 1, 0, '', '', array(128,0,0));
        $html = '
            <b>2-10) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_mimePict.png" width="630" height="378"><br>
        ';
        $pdf->writeHTML($html, true, false, true, false, '');
    };

    if (is_file($path_stat_img.'M'.$this_month.'_mimeComp.png')) {
            $pdf->AddPage('L','A4');
            $pdf->LinearGradient(0, 0, 10, 210, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
            $title = $pdfreport_mimeComp ;
            $pdf->Bookmark('2-11) '.$title.'', 1, 0, '', '', array(128,0,0));
            $html = '
            <b>2-11) '.$title.'</b><br>
            <br>
            <img src="'.$path_stat_img.'M'.$this_month.'_mimeComp.png" width="630" height="378"><br>
            ';
        $pdf->writeHTML($html, true, false, true, false, '');

    };
 

   /*
    3rd Chapter : User activity
    */

    $pdf->AddPage('P','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $title = $pdfreport_accountActivity ;
    $pdf->Bookmark('3) '.$title.'', 0, 0, '', '', array(128,0,0));

    $html = '
    <br><br>
    <b><font size="12px">3) <u>'.$title.'</font></u></b> :<br>
    <br>';
    $pdf->writeHTML($html, true, false, true, false, '');


    $title = $pdfreport_accountSentNb ;
    $pdf->Bookmark('3-1) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html = '
    <br><br>
    <b>3-1) '.$title.'</b> :<br>
    <br>';

    $statm = display_mail_stat_by_user($resm,"TopMailSent");

    $pdf->writeHTML($html, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 8);
    $pdf->writeHTML($statm, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 10);


    $pdf->AddPage('P','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $title = $pdfreport_accountSentVolume ;
    $pdf->Bookmark('3-2) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html = '
    <br><br>
    <b>3-2) '.$title.'</b> :<br>
    <br>';

    $statm = display_mail_stat_by_user($resm,"");

    $pdf->writeHTML($html, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 8);
    $pdf->writeHTML($statm, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 10);


    /*
    4th Chapter : Incoming Domain Activity
    */
    $pdf->AddPage('P','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $title = $pdfreport_incomingDomainActivity." ";
    $pdf->Bookmark('4) '.$title.'', 0, 0, '', '', array(128,0,0));


    $html = '
    <br><br>
    <b><font size="12px">4) <u>'.$title.'</font></u></b> :<br>
    <br>';
    $pdf->writeHTML($html, true, false, true, false, '');


    $title = $pdfreport_incomingDomainNb ;
    $pdf->Bookmark('4-1) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html = '
    <br><br>
    <b>4-1) '.$title.'</b> :<br>
    <br>';

    $statm = display_mail_stat_by_domain($resm,"TopMailSent");

    $pdf->writeHTML($html, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 8);
    $pdf->writeHTML($statm, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 10);


    $pdf->AddPage('P','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $title = $pdfreport_incomingDomainVolume ;
    $pdf->Bookmark('4-2) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html = '
    <br><br>
    <b>4-2) '.$title.'</b> :<br>
    <br>';

    $statm = display_mail_stat_by_domain($resm,"");

    $pdf->writeHTML($html, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 8);
    $pdf->writeHTML($statm, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 10);


    /*
    5th Chapter : Outgoing Domain Activity
    */
    $pdf->AddPage('P','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $title = $pdfreport_outgoingDomainActivity." ";
    $pdf->Bookmark('5) '.$title.'', 0, 0, '', '', array(128,0,0));


    $html = '
    <br><br>
    <b><font size="12px">5) <u>'.$title.'</font></u></b> :<br>
    <br>';
    $pdf->writeHTML($html, true, false, true, false, '');


    $title = $pdfreport_outgoingDomainNb ;
    $pdf->Bookmark('4-1) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html = '
    <br><br>
    <b>4-1) '.$title.'</b> :<br>
    <br>';

    $statm = display_mail_stat_by_domain_outgoing($resm,"TopMailSent");

    $pdf->writeHTML($html, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 8);
    $pdf->writeHTML($statm, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 10);


    $pdf->AddPage('P','A4');
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    $title = $pdfreport_outgoingDomainVolume ;
    $pdf->Bookmark('4-2) '.$title.'', 1, 0, '', '', array(128,0,0));
    $html = '
    <br><br>
    <b>4-2) '.$title.'</b> :<br>
    <br>';

    $statm = display_mail_stat_by_domain_outgoing($resm,"");

    $pdf->writeHTML($html, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 8);
    $pdf->writeHTML($statm, true, false, true, false, '');
    $pdf->SetFont('dejavusans', '', 10);


    /* End of DATA */


    // add a new page for TOC
    $pdf->addTOCPage();
    $pdf->LinearGradient(0, 0, 10, 300, array(0, 75, 123), array(166, 202, 219), array(0, 1, 0, 0));
    // write the TOC title
    $pdf->SetFont('times', 'B', 16);
    $pdf->MultiCell(0, 0, $pdfreport_TOCTitle, 0, 'C', 0, 1, '', '', true, 0);
    $pdf->Ln();
    $pdf->SetFont('dejavusans', '', 12);
    $pdf->addTOC(1, 'courier', '.', 'INDEX', 'B', array(128,0,0));
    $pdf->endTOCPage();



    // switch Page Nr1 and Page Nr2
    $pdf->movePage(2, 1);

    //Close and output PDF document
    $pdf->Output($filename, 'F');


    if( is_file($filename) ) {
        do_email_this($this_domain,$filename) ;
    };
                            

};

?>
